/*
 * BillingView.java
 *
 * Created on 10 de agosto de 2004, 18:04
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.BillingList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.BillingListViewSupplier;

/**
 * Este servlet permite crear los objetos que recibirá el listado facturas que
 * forman parte del estado de facturación del proveedor.
 * 
 * @author andres
 */
public class BillingView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción que se lanza ante un error en la operación de
	 *             inicialización del servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <CODE>GET</CODE> y <CODE>
	 * POST</CODE>.
	 * 
	 * Este método realiza todas las operaciones necesarias para generar la
	 * información requerida por estadofacturación.jsp
	 * 
	 * Crea un objeto <CODE>BillingList</CODE> con el Id del proveedor, este
	 * objeto se envía como parámetro a un objeto <CODE>BillingListViewSupplier
	 * </CODE> el cual se enviará a estadofacturación.jsp como un atributo.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 *             Excepción de fallo en las operaciones del servlet
	 * @throws IOException
	 *             Excepción generada por un fallo al utilizar el PrintWriter
	 *             que hace parte del parámetro response para escribir como un
	 *             flujo de salida.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url;
		String message;


		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				User supplier = (User) session.getAttribute("user");
				BillingList billingList = new BillingList(supplier.getCompanyId());
				BillingListViewSupplier view = new BillingListViewSupplier(billingList);
	
				if( view == null )
				{
					//Falla en la creación del estado de facturación proveedor.
					url = "/proveedor/estadofacturacion.jsp";
					//message = "Error en la construcción del Estado de
					// Facturación.";
					message = MessageBuilder.buildMessage(9);
	
				}
				else
				{
					//Todo OK
					url = "/proveedor/estadofacturacion.jsp";
					//message = "La carga del listado finalizó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("view", view);
				}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en las operaciones del servlet
	 * @throws IOException
	 *             Excepción generada por un fallo al utilizar el PrintWriter
	 *             que hace parte del parámetro response para escribir como un
	 *             flujo de salida.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Handles the HTTP <code>POST</code> method.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en las operaciones del servlet
	 * @throws IOException
	 *             Excepción generada por un fallo al utilizar el PrintWriter
	 *             que hace parte del parámetro response para escribir como un
	 *             flujo de salida.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet
	 * 
	 * @return Retorna información general del servlet en forma de una cadena.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}